#ifndef _VDC_H_
#define _VDC_H_

#include "mainFlags.h"
#include "nrctypes.h"
#include "decDemux.h"
/*
 * Defines
 */

#define VDC_OK 1
#define VDC_ERROR -1


/*
 * Typedefs
 */

typedef struct {
  int32 fStartOfSeq; /* nonzero if in the beginning of sequence */

  int frameNum; /* the number of previous decoded frame */
  int skip;
  int pic_sizex;
  int pic_sizey;

  int IPB; /* 0- P, 2- I*/
  int qp;

  /* Motion compensation related variables */
  int no_of_regions;

  /* Bit rate related variables */
  int32 bits_dct_y;
  int32 bits_dct_u;
  int32 bits_dct_v;
  int32 bits_ovr_y;
  int32 bits_ovr_uv;
  int32 bits_mode;
  int32 frame_bits;
  int32 header_bits;
  int32 total_bits;


  /* Longterm memory related variables */
  int numActiveRefFrames;
  int orderedRefFrames[LONG_TERM_MEM_MAX_SIZE];

  int16
    *slicePredMap;

  objectBuffer_t
    *object_list;

  vdxInstance_t *vdxInstance;

} vdcInstance_t;

/*#define vdcInterface_t vdcInstance_t; */
typedef vdcInstance_t vdcInterface_t;


/*
 * Function prototypes
 */

int vdcCloseCore(vdcInstance_t *instance);

int vdcDecodeFrame(vdcInstance_t *instance, struct frame **longTermMem, 
                   struct frame *predfr, struct frame *recfr, 
                   struct frame *outfr, int *BitError);

void vdcFree(void);

int vdcLoad(void);

vdcInstance_t *vdcOpenCore(int pic_sizex, int pic_sizey);

#endif
