/*
 * encMux.h
 *
 *    Copyright (c) 1995-2000 Nokia Research Center
 *
 * Contains:
 *    Functions for video multiplexer.
 *
 */

#include "toolMCC.h"
#include "decDemux.h"

#define MAX_VLC_LEN 25
#define flor(X) (((X) < 0) ? ((int)(X) - 1) : ((int)(X)))

#define MODE_INTER 1
#define MODE_INTRA 2
#define MODE_COPY  3
#define MODE_INTRA_PRED         5
#define MODE_INTRA_PRED_VSCAN   6
#define MODE_INTRA_PRED_HSCAN   7
#define MODE_INTRA_FRAME        8

#define LAST    2
#define RUN    64
#define RUN4x4 16
#define RUNXx8 32
#define LEVEL 256


extern unsigned char
  (*vectorOftriplet2IndexCubes[5])[LAST][SIZE_8x8][LEVEL_05];
extern vlc_item
  (*vectorOfvlcTable[5])[117],

  vlcTableMethSel[75 * 14],


  (*vectorOfvlcEncRegionMode[11])[];


extern FILE *bitstream_bit;
extern FILE *debug;

int dump8x8BlockAcInfo(int mode, int chroma, int qp, int *tmpDouCnt,
                       int *tmpRdcCnt, int *tmpVqCnt, int *tmpTriCnt,
                       int gen_bitstr_flag);
int dump4x4BlockAcInfo(int mode, int chroma, int qp, int *tmpRdcCnt,
                       int *tmpVqCnt, int *tmpTriCnt,
                       int gen_bitstr_flag);

int SendCncInfoDct(int *cnc_y, int cnc_u, int cnc_v,
		   int regionMode, int regionSize);

int Send_DC_Pred(int level, int chroma);

int dumpLongtermRVLC(int index, int send);
int dumpAffineMotionParams(int *A, int aQP, int send);
int dumpAffineMotionParamsDouble(double *A, int pred, int send);

int put_vlc_item2(vlc_item item, int flush);
int put_bits(int len, int code, int flush, int PSC_em);

int Send_CBPY(int index);
int Send_CBPC(int index);

int Send_Event(int last, int run, int level);
int Send_EventIPred(int last, int run, int level, int long_escape);
int Send_Event4x4Color(int last, int run, int level);

void initTriplet2Index(void);

int intraSendMode(int mode);

int SendPicStart();
int SendEndofSeq();
int SendPicHead(int IPB,           /* 0- P, 2- I      */
                int FrNo, int sliceMode, int useLoopFilter, int QP,
                int pic_sizex, int pic_sizey,
                int numActiveRefFrames, /* Number of reference frames used  */
                int *orderedRefFrames); /* Indexes of reference frames in  
                                         * longterm memory                  */

int SendSliceHead(int mbNum, int intraSliceFlag, int sliceQuant,
                  int frNo, int picSizeX, int picSizeY, int dumpSSC,
                  int sendCriticalParams, int IPB /* 0- P, 2- I*/);

void SendSliceHeaderIfNeeded(int *currSliceID, int *frameBitsAtStartSlice,
                             int *sliceXmin, int *sliceYmin,
                             int *sliceYmax, int *sliceXmax,
                             int picSizeX, int picSizeY,
                             int mbPerLine, int mbIndex, int qp, int frNo,
                             int sliceBits, Bits *bits);

int get_all_bits();
int get_padding_bits();
int get_emulprevent_bits();
void reset_all_bits();

int SendYInfoDct(int *cncY, int regionMode, int regionSize);

int SendCInfoDct(int cncU, int cncV, int regionMode, int regionSize);

int dumpYInfo(int *cnc_y, int xmin, int xmax, int ymin, int ymax, int qp);

int dumpUvInfo(int *cnc_u, int *cnc_v, int regionSize, int qp);

int SendDctOrKlt_EventXxX(int last, int run, int level,
                          int tableNo, int runBits, int levelBits,
                          int gen_bitstr_flag);
/* Fast version of SendDctOrKlt for use by calcDctBits       */
/* If using this function, it really important to initialize */
/* in the main module first by doing :                       */
/*   initTriplet2Index();                                    */
int SendDctOrKlt_EventXxX_FAST(int last, int run, int level,
                               int tableNo, int runBits,
                               int levelBits, int escapeInd,
                               vlc_item *vlcTable);

int SendMethSel_Event(int tableNo, int rankNo, int gen_bitstr_flag);

void bmIndexToIndex(int bmIndex, int *index);

int SendSelDcdCncSign_Event(int preNum, int selRank, int dcdIndex, int cncValue, int sign,
                            int qp, int gen_bitstr_flag);

int SendBMV_Event(int dY, int dX, int reducedSearchRange, int gen_bitstr_flag);



