#ifndef _MOTIONOPT_H_
#define _MOTIONOPT_H_


/*
 * Definition of functions in motionOpt.c
 */

void motInitialEstimation32x32(object *objectList,
                               struct frame *currFr,
                               struct frame **longTermMem,
                               Byte *currSubsampled,
                               Byte **prevSubsampled,
                               int posX, int posY,
                               int picSizeX, int picSizeY,
                               int numRefFrames, int qp,
                               double lambda,
                               int complexityMode, int *BMvectors);

void motEstimateMacroblock(object *objectList,
                           struct frame *currFr,
                           struct frame *prevFr,
                           Byte *subsCurrY,
                           Byte *subsPrevY,
                           int mbPosX, int mbPosY,
                           int picSizeX, int picSizeY,
                           int qp, double lambda,
                           int numRefFrames,
                           int complexityMode, int *BMvectors,
                           int refFrame);

void motFindFinalMotionAndMode(object *objectList,
                               struct frame *currFr,
                               struct frame **longTermMem,
                               struct frame *predFr,
                               struct frame *predBuffer,
                               int mbPosX, int mbPosY,
                               int picSizeX, int picSizeY,
                               int qp, int aQP, double lambda,
                               int *lagrNoLTM,
                               int currSliceID,
                               int complexityMode,
                               int numRefFrames);

void motBuildMBPrediction(object *currRegion16,
                          struct frame *prevFr,
                          struct frame *predFr,
                          struct frame *predBuffer,
                          int picSizeX, int picSizeY);

void motPrepareSubsampledImages(Byte **prevSubsampled,
                                Byte **currSubsampled,
                                struct frame **longTermMem,
                                struct frame *currFr,
                                int picSizeX, int picSizeY);

#endif
