#ifndef TOOLS_H
#define TOOLS_H

#include "mainFlags.h"

void givens(double g[2],double a,double b);

void transMvDeltasToGlobPoly(int32 *affineData, double *motCoefGlob,
			                       int xPos, int yPos,int picSizeX, int picSizeY);
void orthQuantParams(double *motCoef, int *motCoefQuant, int aQP);

void transGlobPolyToMvDeltas(double *motCoefGlob,int32 *affineData, 
			                       int xPos, int yPos,int picSizeX, int picSizeY);

double Se_8x8(double xstepx, double xstepy, double ystepx, double ystepy,
	            Byte *curr, int i, int j, double iprev1, double jprev1,
	            Byte *prev);

void subsBlkMatching(object *region, Byte *prev, Byte *curr,
                     int n, int m, int *vecX, int *vecY);
void MatchBlock(Byte *prev, Byte *curr, int x, int y,
                int blk_size, int sizex, int sizey,
                int *vecX, int *vecY);

void splSetPicSize(int sx, int sy);
void splInitInterpArray(void);
void splInitDerivativeArray(void);
double splInterpolation(Byte *yin, double i, double j, int m, int n);

typedef struct {
  int last;
  int run;
  int level;
} triplet;

typedef struct {
  int transform;
  int class;
} doublet;
struct vlc_table
{
  int code;
  int length;
};

int gnsCholeskyDec(double inpMatr[6][6] , double outMatr[6][6] );

void gnsTransposeBacksubstitution(double U[6][6], double rhs[], 
                                  double x[], int order);
void gnsBacksubstitution(double R[6][6], double z[6], int R_size, double A[6]);

int gnsBuildTriangLsEqnCRem(Byte *prevY, Byte *currY,
                            object *currRegion,
                            int picSizeX, int picSizeY,
                            double U[6][6], double uRhs[6],
                            double *partialSum,
                            double LHS[6][6], double rhs[6],
                            double motCoefGlob[6],
                            double motCoefGlobDelta[6]);

void alloc_triplets_if_needed(long picSize);

#endif /* ifndef TOOLS_H */
